SPOJ 7001

这次求的是三维的。如上篇一样,使用那个特殊的莫比乌斯反演来做。

需要注意的是,求得的只是从(1,1,1)到(n,n,n)的互质的个数,还要注意墙壁三面如(0,1,1)~(0,n,n)等。最后+3。因为是(0,0,1);

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#define N 1000005

using namespace std;
typedef long long LL;
int mobi[N];
bool vis[N];
int n;

void initial(){
    int i,j;
    for(i=1;i<N;i++) mobi[i]=1,vis[i]=false;
    for(i=2;i<N;i++) {
        if(vis[i]) continue;
        for(j=i;j<N;j+=i){
            vis[j]=true;
            if((j/i)%i==0){
                mobi[j]=0; continue;
            }
            mobi[j]=-mobi[j];
        }
    }
}

int main(){
	initial();
	int T;
	scanf("%d",&T);
	while(T--){
		scanf("%d",&n);
		LL ans=0;
		for(int i=1;i<=n;i++){
			ans+=((LL)mobi[i]*(LL)(n/i)*(LL)(n/i)*(LL)(n/i)+3*(LL)mobi[i]*(LL)(n/i)*(LL)(n/i));
		}
		ans+=3;
		printf("%lld\n",ans);
	}
	return 0;
}

  

时间: 2024-10-18 22:34:57

SPOJ 7001的相关文章

zoj 3435 spoj 7001 莫比乌斯反演

zoj 3435 题意: 给出3个数a,b,c, 定义一个立方体,这个立方体有a*b*c个点,每个点的坐标都是整数(x,y,z),求经过坐标(1,1,1)和另外任意一个点(x1,y1,z1)的不同的直线有多少条. 限制: 2 <= a,b,c <= 1e6; 有200组数据. 思路: 有3种情况: 1. x1,y1,z1都大于等于2: 问题就变成求1 <= x <= a-1 && 1 <= y <= b-1 && 1 <= z &l

spoj 7001 Visible Lattice Points莫比乌斯反演

Visible Lattice Points Time Limit:7000MS     Memory Limit:0KB     64bit IO Format:%lld & %llu Submit Status Description Consider a N*N*N lattice. One corner is at (0,0,0) and the opposite one is at (N,N,N). How many lattice points are visible from co

SPOJ 7001(莫比乌斯反演)

传送门:Visible Lattice Points 题意:0<=x,y,z<=n,求有多少对xyz满足gcd(x,y,z)=1. 设f(d) = GCD(a,b,c) = d的种类数 : F(n) 为GCD(a,b,c) = d 的倍数的种类数, n%a == 0 n%b==0 n%c==0. 即 :F(d) = (N/d)*(N/d)*(N/d); 则f(d) = sigma( mu[n/d]*F(n), d|n ) 由于d = 1 所以f(1) = sigma( mu[n]*F(n) )

SPOJ 705 Distinct Substrings(后缀数组)

[题目链接] http://www.spoj.com/problems/SUBST1/ [题目大意] 给出一个串,求出不相同的子串的个数. [题解] 对原串做一遍后缀数组,按照后缀的名次进行遍历, 每个后缀对答案的贡献为n-sa[i]+1-h[i], 因为排名相邻的后缀一定是公共前缀最长的, 那么就可以有效地通过LCP去除重复计算的子串. [代码] #include <cstdio> #include <cstring> #include <algorithm> usi

SPOJ 3273

传送门: 这是一道treap的模板题,不要问我为什么一直在写模板题 依旧只放代码 1 //SPOJ 3273 2 //by Cydiater 3 //2016.8.31 4 #include <iostream> 5 #include <cstring> 6 #include <ctime> 7 #include <cmath> 8 #include <cstdlib> 9 #include <string> 10 #include

SPOJ CRAN02 - Roommate Agreement

题目链接:http://www.spoj.com/problems/CRAN02/ 题目大意:N个数字组成的序列,和为0的连续子序列的个数.N<1e6 解题思路:计算前缀和,统计每个数字出现的次数,那么对于数字sum[i], 如果存在k个sum[i],则代表有C(k, 2)个序列和为0,而如果sum[i] = 0,则还要累加上对应的k值. 代码: 1 ll n; 2 int a[maxn]; 3 ll sum[maxn]; 4 map<int, int> mmp; 5 6 void so

spoj GCJ1C09C Bribe the Prisoners

题目链接: http://www.spoj.com/problems/GCJ1C09C/ 题意: In a kingdom there are prison cells (numbered 1 to P) built to form a straight line segment. Cells number i and i+1 are adjacent, and prisoners in adjacent cells are called "neighbours." A wall wi

SPOJ QTREE Query on a tree ——树链剖分 线段树

[题目分析] 垃圾vjudge又挂了. 树链剖分裸题. 垃圾spoj,交了好几次,基本没改动却过了. [代码](自带常数,是别人的2倍左右) #include <cstdio> #include <cstring> #include <iostream> #include <algorithm> using namespace std; #define maxn 20005 int T,n,fr[maxn],h[maxn],to[maxn],ne[maxn]

BZOJ 2588: Spoj 10628. Count on a tree 主席树+lca

2588: Spoj 10628. Count on a tree Description 给定一棵N个节点的树,每个点有一个权值,对于M个询问(u,v,k),你需要回答u xor lastans和v这两个节点间第K小的点权.其中lastans是上一个询问的答案,初始为0,即第一个询问的u是明文. Input 第一行两个整数N,M. 第二行有N个整数,其中第i个整数表示点i的权值. 后面N-1行每行两个整数(x,y),表示点x到点y有一条边. 最后M行每行两个整数(u,v,k),表示一组询问.